tests/utils/utils.sh: use `[[ ... ]]` instead of `[` or `test`
[babeltrace.git] / tests / utils / utils.sh
index 393cf1633b3da3061a78e2f0b6b01f499c291ea2..45439ac3893f581314957a125d54c694b0ee18d9 100644 (file)
@@ -40,7 +40,7 @@ set -u
 #
 # Do some translation to ease our life down the road for comparison.
 # Export it so that executed commands can use it.
-if [ -z "${BT_TESTS_OS_TYPE:-}" ]; then
+if [[ -z "${BT_TESTS_OS_TYPE:-}" ]]; then
        BT_TESTS_OS_TYPE="$(uname -s)"
        case "$BT_TESTS_OS_TYPE" in
        MINGW*)
@@ -80,13 +80,13 @@ _set_vars_srcdir_builddir() {
        fi
 
        # Base source directory of tests
-       if [ -z "${BT_TESTS_SRCDIR:-}" ]; then
+       if [[ -z "${BT_TESTS_SRCDIR:-}" ]]; then
                BT_TESTS_SRCDIR="$testsdir"
        fi
        export BT_TESTS_SRCDIR
 
        # Base build directory of tests
-       if [ -z "${BT_TESTS_BUILDDIR:-}" ]; then
+       if [[ -z "${BT_TESTS_BUILDDIR:-}" ]]; then
                BT_TESTS_BUILDDIR="$testsdir"
        fi
        export BT_TESTS_BUILDDIR
@@ -99,7 +99,7 @@ unset -f _set_vars_srcdir_builddir
 _source_env_sh() {
        local -r env_sh_path="$BT_TESTS_BUILDDIR/utils/env.sh"
 
-       if [ -f "${env_sh_path}" ]; then
+       if [[ -f "${env_sh_path}" ]]; then
                # shellcheck disable=SC1090,SC1091
                . "${env_sh_path}"
        fi
@@ -109,10 +109,10 @@ _source_env_sh
 unset -f _source_env_sh
 
 # Path to the `babeltrace2` command, if not set
-if [ -z "${BT_TESTS_BT2_BIN:-}" ]; then
+if [[ -z "${BT_TESTS_BT2_BIN:-}" ]]; then
        BT_TESTS_BT2_BIN="$BT_TESTS_BUILDDIR/../src/cli/babeltrace2"
-       if [ "$BT_TESTS_OS_TYPE" = "mingw" ]; then
-               BT_TESTS_BT2_BIN="${BT_TESTS_BT2_BIN}.exe"
+       if [[ "$BT_TESTS_OS_TYPE" == "mingw" ]]; then
+               BT_TESTS_BT2_BIN+=".exe"
        fi
 fi
 export BT_TESTS_BT2_BIN
@@ -124,37 +124,37 @@ export BT_TESTS_BT2_BIN
 _bt_tests_plugins_path="${BT_TESTS_BUILDDIR}/../src/plugins"
 
 # Colon-separated list of project plugin paths, if not set
-if [ -z "${BT_TESTS_BABELTRACE_PLUGIN_PATH:-}" ]; then
+if [[ -z "${BT_TESTS_BABELTRACE_PLUGIN_PATH:-}" ]]; then
        BT_TESTS_BABELTRACE_PLUGIN_PATH="${_bt_tests_plugins_path}/ctf:${_bt_tests_plugins_path}/utils:${_bt_tests_plugins_path}/text:${_bt_tests_plugins_path}/lttng-utils"
 fi
 export BT_TESTS_BABELTRACE_PLUGIN_PATH
 
 # Directory containing the Python plugin provider library, if not set
-if [ -z "${BT_TESTS_PROVIDER_DIR:-}" ]; then
+if [[ -z "${BT_TESTS_PROVIDER_DIR:-}" ]]; then
        BT_TESTS_PROVIDER_DIR="${BT_TESTS_BUILDDIR}/../src/python-plugin-provider/.libs"
 fi
 export BT_TESTS_PROVIDER_DIR
 
 # Directory containing the built `bt2` Python package, if not set
-if [ -z "${BT_TESTS_PYTHONPATH:-}" ]; then
+if [[ -z "${BT_TESTS_PYTHONPATH:-}" ]]; then
        BT_TESTS_PYTHONPATH="${BT_TESTS_BUILDDIR}/../src/bindings/python/bt2/build/build_lib"
 fi
 export BT_TESTS_PYTHONPATH
 
 # Name of the `awk` command to use when testing, if not set
-if [ -z "${BT_TESTS_AWK_BIN:-}" ]; then
+if [[ -z "${BT_TESTS_AWK_BIN:-}" ]]; then
        BT_TESTS_AWK_BIN="awk"
 fi
 export BT_TESTS_AWK_BIN
 
 # Name of the `grep` command to use when testing, if not set
-if [ -z "${BT_TESTS_GREP_BIN:-}" ]; then
+if [[ -z "${BT_TESTS_GREP_BIN:-}" ]]; then
        BT_TESTS_GREP_BIN="grep"
 fi
 export BT_TESTS_GREP_BIN
 
 # Name of the `python3` command to use when testing, if not set
-if [ -z "${BT_TESTS_PYTHON_BIN:-}" ]; then
+if [[ -z "${BT_TESTS_PYTHON_BIN:-}" ]]; then
        BT_TESTS_PYTHON_BIN="python3"
 fi
 export BT_TESTS_PYTHON_BIN
@@ -166,19 +166,19 @@ export BT_TESTS_PYTHON_BIN
 _bt_tests_py3_version=$("$BT_TESTS_PYTHON_BIN" -c 'import sys; print("{}.{}".format(sys.version_info.major, sys.version_info.minor))')
 
 # Name of the `python3-config` command to use when testing, if not set
-if [ -z "${BT_TESTS_PYTHON_CONFIG_BIN:-}" ]; then
+if [[ -z "${BT_TESTS_PYTHON_CONFIG_BIN:-}" ]]; then
        BT_TESTS_PYTHON_CONFIG_BIN="python3-config"
 fi
 export BT_TESTS_PYTHON_CONFIG_BIN
 
 # Name of the `sed` command to use when testing, if not set
-if [ -z "${BT_TESTS_SED_BIN:-}" ]; then
+if [[ -z "${BT_TESTS_SED_BIN:-}" ]]; then
        BT_TESTS_SED_BIN="sed"
 fi
 export BT_TESTS_SED_BIN
 
 # Name of the `cc` command to use when testing, if not set
-if [ -z "${BT_TESTS_CC_BIN:-}" ]; then
+if [[ -z "${BT_TESTS_CC_BIN:-}" ]]; then
        BT_TESTS_CC_BIN="cc"
 fi
 export BT_TESTS_CC_BIN
@@ -187,7 +187,7 @@ export BT_TESTS_CC_BIN
 #
 # This doesn't need to be exported from the point of view of this file,
 # but the sourced `env.sh` above does export it.
-if [ -z "${BT_TESTS_ENABLE_ASAN:-}" ]; then
+if [[ -z "${BT_TESTS_ENABLE_ASAN:-}" ]]; then
        BT_TESTS_ENABLE_ASAN="0"
 fi
 
@@ -198,7 +198,7 @@ BT_TESTS_DATADIR="${BT_TESTS_SRCDIR}/data"
 BT_CTF_TRACES_PATH="${BT_TESTS_DATADIR}/ctf-traces"
 
 # Source the shell TAP utilities if `SH_TAP` is `1`
-if [ "${SH_TAP:-}" = 1 ]; then
+if [[ "${SH_TAP:-}" == 1 ]]; then
        # shellcheck source=./tap/tap.sh
        . "${BT_TESTS_SRCDIR}/utils/tap/tap.sh"
 fi
@@ -232,7 +232,7 @@ bt_cli() {
        shift 2
        local -r args=("$@")
 
-       echo "Running: $BT_TESTS_BT2_BIN ${args[*]}" >&2
+       echo "Running: \`$BT_TESTS_BT2_BIN ${args[*]}\`" >&2
        run_python_bt2 "$BT_TESTS_BT2_BIN" "${args[@]}" 1>"$stdout_file" 2>"$stderr_file"
 }
 
@@ -249,11 +249,8 @@ bt_cli() {
 bt_diff() {
        local -r expected_file="$1"
        local -r actual_file="$2"
-       local ret=0
 
        diff -u <(bt_remove_cr_inline "$expected_file") <(bt_remove_cr_inline "$actual_file") 1>&2
-
-       return $?
 }
 
 # Checks the difference between:
@@ -280,7 +277,6 @@ bt_diff_cli() {
 
        local -r temp_stdout_output_file="$(mktemp -t actual-stdout.XXXXXX)"
        local -r temp_stderr_output_file="$(mktemp -t actual-stderr.XXXXXX)"
-       local ret=0
 
        bt_cli "$temp_stdout_output_file" "$temp_stderr_output_file" "${args[@]}"
 
@@ -289,13 +285,9 @@ bt_diff_cli() {
        bt_diff "$expected_stderr_file" "$temp_stderr_output_file" "${args[@]}"
        local -r ret_stderr=$?
 
-       if ((ret_stdout != 0 || ret_stderr != 0)); then
-               ret=1
-       fi
-
        rm -f "$temp_stdout_output_file" "$temp_stderr_output_file"
 
-       return $ret
+       return $((ret_stdout || ret_stderr))
 }
 
 # Checks the difference between:
@@ -316,10 +308,9 @@ bt_diff_details_ctf_single() {
        local -r trace_dir="$2"
        shift 2
        local -r extra_details_args=("$@")
-       expected_stderr_file="/dev/null"
 
        # Compare using the CLI with `sink.text.details`
-       bt_diff_cli "$expected_stdout_file" "$expected_stderr_file" "$trace_dir" \
+       bt_diff_cli "$expected_stdout_file" /dev/null "$trace_dir" \
                "-c" "sink.text.details" "${extra_details_args[@]+${extra_details_args[@]}}"
 }
 
@@ -338,7 +329,7 @@ bt_diff_details_ctf_gen_single() {
 
        # Run the CTF trace generator program to get a CTF trace
        if ! "$ctf_gen_prog_path" "$temp_trace_dir" 2>/dev/null; then
-               echo "ERROR: \"$ctf_gen_prog_path\" \"$temp_trace_dir\" failed" >&2
+               echo "ERROR: \`$ctf_gen_prog_path $temp_trace_dir\` failed" >&2
                rm -rf "$temp_trace_dir"
                return 1
        fi
@@ -356,31 +347,34 @@ bt_grep() {
        "$BT_TESTS_GREP_BIN" "$@"
 }
 
-# ok() with the test name `$3` on the result of bt_grep() matching the
-# pattern `$1` within the file `$2`.
-bt_grep_ok() {
-       local -r pattern=$1
-       local -r file=$2
-       local -r test_name=$3
-
-       bt_grep --silent "$pattern" "$file"
-
-       local -r ret=$?
-
-       if ! ok $ret "$test_name"; then
-               {
-                       echo "Pattern \`$pattern\` doesn't match the contents of \`$file\`:"
-                       echo '--- 8< ---'
-                       cat "$file"
-                       echo '--- >8 ---'
-               } >&2
-       fi
+# Only if `tap.sh` is sourced because bt_grep_ok() uses ok()
+if [[ ${SH_TAP:-} == 1 ]]; then
+       # ok() with the test name `$3` on the result of bt_grep() matching
+       # the pattern `$1` within the file `$2`.
+       bt_grep_ok() {
+               local -r pattern=$1
+               local -r file=$2
+               local -r test_name=$3
+
+               bt_grep --silent "$pattern" "$file"
+
+               local -r ret=$?
+
+               if ! ok $ret "$test_name"; then
+                       {
+                               echo "Pattern \`$pattern\` doesn't match the contents of \`$file\`:"
+                               echo '--- 8< ---'
+                               cat "$file"
+                               echo '--- >8 ---'
+                       } >&2
+               fi
 
-       return $ret
-}
+               return $ret
+       }
+fi
 
 # Forwards the arguments to `coverage run`.
-check_coverage() {
+_bt_tests_check_coverage() {
        coverage run "$@"
 }
 
@@ -402,7 +396,6 @@ run_python() {
 # Executes a command within an environment which can import the testing
 # Python modules (in `tests/utils/python`) and the `bt2` Python package.
 run_python_bt2() {
-       local lib_asan
        local -x "BABELTRACE_PLUGIN_PATH=${BT_TESTS_BABELTRACE_PLUGIN_PATH}"
        local -x "LIBBABELTRACE2_PLUGIN_PROVIDER_DIR=${BT_TESTS_PROVIDER_DIR}"
        local -x "BT_TESTS_DATADIR=${BT_TESTS_DATADIR}"
@@ -410,13 +403,13 @@ run_python_bt2() {
        local -x "BT_PLUGINS_PATH=${_bt_tests_plugins_path}"
        local -x "PYTHONPATH=${BT_TESTS_PYTHONPATH}${PYTHONPATH:+:}${PYTHONPATH:-}"
 
-       local main_lib_path="${BT_TESTS_BUILDDIR}/../src/lib/.libs"
+       local -r main_lib_path="${BT_TESTS_BUILDDIR}/../src/lib/.libs"
 
        # Set the library search path so that the Python 3 interpreter can
        # load `libbabeltrace2`.
-       if [ "$BT_TESTS_OS_TYPE" = "mingw" ] || [ "$BT_TESTS_OS_TYPE" = "cygwin" ]; then
+       if [[ "$BT_TESTS_OS_TYPE" == "mingw" || "$BT_TESTS_OS_TYPE" == "cygwin" ]]; then
                local -x PATH="${main_lib_path}${PATH:+:}${PATH:-}"
-       elif [ "$BT_TESTS_OS_TYPE" = "darwin" ]; then
+       elif [[ "$BT_TESTS_OS_TYPE" == "darwin" ]]; then
                local -x DYLD_LIBRARY_PATH="${main_lib_path}${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH:-}"
        else
                local -x LD_LIBRARY_PATH="${main_lib_path}${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH:-}"
@@ -425,7 +418,7 @@ run_python_bt2() {
        # On Windows, an embedded Python 3 interpreter needs a way to locate
        # the path to its internal modules: set the `PYTHONHOME` variable to
        # the prefix from `python3-config`.
-       if [ "$BT_TESTS_OS_TYPE" = "mingw" ]; then
+       if [[ "$BT_TESTS_OS_TYPE" == "mingw" ]]; then
                local -x PYTHONHOME
 
                PYTHONHOME=$("$BT_TESTS_PYTHON_CONFIG_BIN" --prefix)
@@ -439,9 +432,9 @@ run_python_bt2() {
        #
        # Append it to existing `ASAN_OPTIONS` variable, such that we
        # override the user's value if it contains `detect_leaks=1`.
-       if [ "${BT_TESTS_ENABLE_ASAN:-}" = "1" ]; then
+       if [[ "${BT_TESTS_ENABLE_ASAN:-}" == "1" ]]; then
                if "${BT_TESTS_CC_BIN}" --version | head -n 1 | bt_grep -q '^gcc'; then
-                       lib_asan="$("${BT_TESTS_CC_BIN}" -print-file-name=libasan.so)"
+                       local -r lib_asan="$("${BT_TESTS_CC_BIN}" -print-file-name=libasan.so)"
                        local -x LD_PRELOAD="${lib_asan}${LD_PRELOAD:+:}${LD_PRELOAD:-}"
                fi
 
@@ -458,19 +451,13 @@ run_python_bt2() {
 # the testing Python modules (in `tests/utils/python`) and the `bt2`
 # Python package.
 run_python_bt2_test() {
-       local test_dir="$1"
-       local test_pattern="${2:-'*'}"
+       local -r test_dir="$1"
+       local -r test_pattern="${2:-'*'}"
 
-       local ret
-       local test_runner_args=()
+       local python_exec
 
-       test_runner_args+=("$test_dir")
-       if [ -n "${test_pattern}" ]; then
-               test_runner_args+=("${test_pattern}")
-       fi
-
-       if test "${BT_TESTS_COVERAGE:-}" = "1"; then
-               python_exec="check_coverage"
+       if [[ "${BT_TESTS_COVERAGE:-}" == "1" ]]; then
+               python_exec="_bt_tests_check_coverage"
        else
                python_exec="${BT_TESTS_PYTHON_BIN}"
        fi
@@ -481,13 +468,13 @@ run_python_bt2_test() {
                --pattern "$test_pattern" \
                "$test_dir" \
 
-       ret=$?
+       local -r ret=$?
 
-       if test "${BT_TESTS_COVERAGE_REPORT:-}" = "1"; then
+       if [[ "${BT_TESTS_COVERAGE_REPORT:-}" == "1" ]]; then
                coverage report -m
        fi
 
-       if test "${BT_TESTS_COVERAGE_HTML:-}" = "1"; then
+       if [[ "${BT_TESTS_COVERAGE_HTML:-}" == "1" ]]; then
                coverage html
        fi
 
@@ -497,10 +484,14 @@ run_python_bt2_test() {
 # Generates a CTF trace into the directory `$2` from the moultipart
 # document `$1` using `mctf.py`.
 gen_mctf_trace() {
-       local input_file="$1"
-       local base_dir="$2"
-
-       diag "Running: ${BT_TESTS_PYTHON_BIN} ${BT_TESTS_SRCDIR}/utils/python/mctf.py --base-dir ${base_dir} ${input_file}"
-       run_python "${BT_TESTS_PYTHON_BIN}" "${BT_TESTS_SRCDIR}/utils/python/mctf.py" \
-               --base-dir "${base_dir}" "${input_file}"
+       local -r input_file="$1"
+       local -r base_dir="$2"
+       local -r cmd=(
+               "$BT_TESTS_PYTHON_BIN" "$BT_TESTS_SRCDIR/utils/python/mctf.py"
+               --base-dir "$base_dir"
+               "$input_file"
+       )
+
+       echo "Running: \`${cmd[*]}\`" >&2
+       run_python "${cmd[@]}"
 }
This page took 0.028567 seconds and 4 git commands to generate.